#include "decl.h"

int c_n0_map(int C_N0,double c_n0_lim[3])

     // This function converts C/N0 value of a RIMS measurement to a
     // value 1 - 9 for the rinex file. Linear mapping in two ranges 1-5
     // and 5-9 using limits read from the control file.
     //
     // Input  C_N0     : RIMS measurement C/N0
     //        c_n0_lim : conversion limit values from control file
     //
     // Output c_n0_map : snr value for the rinex file

{
  int snr_flag;
  
  if (C_N0 >= (int)(c_n0_lim[1]+0.5)) 
    snr_flag= 5 + (int)(4.0*((double)C_N0-c_n0_lim[1])/(c_n0_lim[2]-c_n0_lim[1])+0.5);
  else 
    snr_flag= 1 + (int)(4.0*((double)C_N0-c_n0_lim[0])/(c_n0_lim[1]-c_n0_lim[0])+0.5);

  // If values outside the rinex 1-9 limit:
  if (snr_flag<1) snr_flag=1;
  if (snr_flag>9) snr_flag=9;
  
  return snr_flag;

}
