#include "decl.h"

double decode_diff_pseudo_range(unsigned char in_bytes[2])

     // This function decodes two bytes for the difference between 
     // P2 and C1 pseudorange measurements.
     // See EGNOS CCF Interface Control Document (CCF ICD)
     // Annex 2, SV Delta PseudoRange
     //
     // Input  in_bytes                 : RIMS file bytes to decode
     //
     // Output decode_diff_pseudo_range : P2-C1 difference

{
  double dp_range;

  dp_range=(double)(2.0*in_bytes[0]+0.0078125*in_bytes[1]-156.0);

  return dp_range;
}

