#include "decl.h"

double decode_pseudo_range(unsigned char in_bytes[5])

     // This function decodes the RIMS pseudo range observables.
     // See EGNOS CCF Interface Control Document (CCF ICD)
     // Annex 2, SV Biased PseudoRange
     //
     // Input  in_bytes            : RIMS raw measurement bytes to convert
     //
     // Output decode_pseudo_range : new phase observation

{
  double p_range;

  p_range=(double)(33554432.0*in_bytes[0]+131072.0*in_bytes[1]+    
    512.0*in_bytes[2]+2.0*in_bytes[3]+0.0078125*in_bytes[4]-4.3e9);

  return p_range;
}

