#include "decl.h"

int extract_rims_station(char rims_sta[5],char rimsf_name[80])

     // This function extracts the 5 character RIMS station code
     // from a RIMS file name provided that the name has a
     // standardized structure.
     // The standard file name and file structure is found in
     // Annex A to CCF ICD: 9.1 CCF Archive Data to PACF
     //
     // Input  rimsf_name           : RIMS file name
     //
     // Output rims_sta             : RIMS station code
     //        extract_rims_station : (boolean) 1 if extraction ok

{
  int sl,extract_ok=0;

  // find length of name string, might contain path
  sl=strlen(rimsf_name);

  // standard name contains 36 character
  // (e.g. "RIMS_A_Raw_Data_0010_20040402_221140") 
  if (sl >= 36)
    // check if the last 36 characters seem to be standard
    if ((strncmp(rimsf_name+sl-36,"RIMS_",5)==0)&&
        (strncmp(rimsf_name+sl-36+6,"_Raw_Data_",10)==0))
      {
      // if standard name extract type ("A" or "B")
      strncpy(rims_sta,rimsf_name+sl-36+5,1);
      // extract 4 digit (character) station number
      strncpy(rims_sta+1,rimsf_name+sl-36+16,4);
      extract_ok=1;
      }
  return extract_ok;

}

