#include "decl.h"

void name_sort(char final_list[max_n_rims][80],char temp_list[max_n_rims][80],
               int n_names,int sorting)

     // This function takes a list of file names and sort them by order of 
     // their ASCII sign values.
     //
     // Input  temp_list  : original list of names
     //        n_names    : number of names
     //        sorting    : (boolean) 1 if sorting wanted, 0 just copy list 
     //
     // Output final_list : resulting list of names

{
  int i,j,name_used[max_n_rims],pick_name;

  if (sorting)
    {
    // reset the sorting indicators; no names sorted yet
    for (i=0; i < n_names; i++) name_used[i]=0;

    // loop over order in the final_list
    for (i=0; i < n_names; i++)
      {
      // set default choise for position i of final list
      pick_name=0;

      // loop over candidates for position i of final_list      
      for (j=0; j < n_names; j++) 
        // if j not used yet, and better than last candidate 
        // OR the present (default) pick_name is alredy used: pick j instead
        if (((!name_used[j])&&(strcmp(temp_list[pick_name],temp_list[j])>=0))||
            (name_used[pick_name])) pick_name=j;
      // j loop ready, now copy the right name into position i of final list 
      strcpy(final_list[i],temp_list[pick_name]);
      // mark that name is used 
      name_used[pick_name]=1;
      }
    }
  else  
    // no sorting, just copy the temp_list to final_list
    for (i=0; i < n_names; i++) strcpy(final_list[i],temp_list[i]);


}
