#include "decl.h"

u32 pppfcs32(register u32 fcs, register unsigned char *cp, register int len)

     // This function calculates 
     // a new FCS given the current FCS and the new data.
     //
     // The code used for the CRC32 check is taken from the document
     // "IETF RFC.1662 CRC32"
     // which is listed as an "applicable document" for the
     // EGNOS CCF Interface Control Document (CCF ICD)
     //
     // Input  fcs      : last CRC32 frame check sum
     //        cp       : input data
     //        len      : number of data
     //
     // Output pppfcs32 : new CRC32 frame check sum

{

//       ASSERT(sizeof (u32) == 4);
//       ASSERT(((u32) -1) > 0);
       while (len--)
           fcs = (((fcs) >> 8) ^ fcstab_32[((fcs) ^ (*cp++)) & 0xff]);

       return (fcs);
       }

