#include "decl.h"

int read_ctl_dbl(double *out_dbl,char type_str[20],int line_nr,FILE *fd_ctl)

     // This function reads a line from the control file,
     // checks if the line begins with the expected token, and
     // a (double) variable value from the control file
     //
     // Input  type_str     : expected control file token
     //        line_nr      : line number in control file block that is read
     //        fd_ctl       : station control file
     //
     // Output out_dbl      : extracted variable value
     //        read_ctl_str : (boolean) 1 if reading successful

{
  int n_type_char,test,read_ok=1;
  char in_str[120];

  // length of the expected token
  n_type_char=strlen(type_str);

  // read the new line from the control file
  fgets(in_str,120,fd_ctl);
  // check if the start of the new line agrees with the expected token
  if (strncmp(in_str,type_str,n_type_char)!=0)
    {
    fprintf(stderr, "Line %d after the station identifier in control file should begin:%s%s%s",
                     line_nr,lin_end,type_str,lin_end);
    read_ok=0;
    }
  else 
    {
    // read the data after the token on the new line
    test=sscanf(in_str+n_type_char,"%lf",out_dbl);
    // check if reading was successful
    if (test!=1)
      {
      fprintf(stderr, "Cannot read line %d after the station identifier in control file%s",
                       line_nr,lin_end);
      read_ok=0;
      }
    }

  return read_ok;
}
