#include "decl.h"

int read_ctl_str(char out_str[60],char type_str[20],int n_read_char,int line_nr,FILE *fd_ctl)

     // This function reads a line from the control file,
     // checks if the line begins with the expected token, and
     // extracts the information from the control file
     //
     // Input  type_str     : expected control file token
     //        n_read_char  : exact # characters in the extracted response
     //        line_nr      : line number in control file block that is read
     //        fd_ctl       : station control file
     //
     // Output out_str      : extracted response string
     //        read_ctl_str : (boolean) 1 if reading successful

{
  int i,n_type_char,n_response_char,read_ok=1;
  char in_str[120];

  // length of the expected token
  n_type_char=strlen(type_str);

  // read the new line from the control file
  fgets(in_str,120,fd_ctl);
  // check if the start of the new line agrees with the expected token
  if (strncmp(in_str,type_str,n_type_char)!=0)
    {
    fprintf(stderr, "Line %d after the station identifier in control file should begin:%s%s%s",
                     line_nr,lin_end,type_str,lin_end);
    read_ok=0;
    }
  else 
    {
    // Find length of the output response string
    n_response_char=strlen(in_str)-n_type_char;
    // don't count line end characters
    while ((n_response_char>0)&&
           ((in_str[n_type_char+n_response_char-1]=='\r')||
            (in_str[n_type_char+n_response_char-1]=='\n'))) n_response_char--; 
    // truncate the response if longer than the allocation
    if (n_response_char>n_read_char) n_response_char=n_read_char;
    // Fill the output string with blanks
    for (i=0; i < n_read_char; i++) out_str[i]=' ';
    // Then copy the exact amount of useful characters to the output string
    strncpy(out_str,in_str+n_type_char,n_response_char);
    }

  return read_ok;
}



