#include "decl.h"

void s2ymdhms(int dat[6], long s)

     // This function converts the number of GPS seconds to
     // time and date
     //
     // Input  s   : number of GPS seconds
     //
     // Output dat : year,months,days,hours,minutes,seconds

{
  int i,secs_in_day,n_days,days_in_year;
  double n_days_d;
  int days_before_month_n[]={0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334};
  int days_before_month_l[]={0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335};

/* s is the number of seconds since 1980 01 06 00 00 00 UTC. */
/* Assumes date between 1901 and 2099. */
/* The date is a 'time in GPS seconds' */

  secs_in_day=(int)(s%86400);
 
  dat[3]=secs_in_day/3600;
  dat[4]=(secs_in_day-3600*dat[3])/60;
  dat[5]=secs_in_day-3600*dat[3]-60*dat[4];

  /* add 5 days to adjust the start time to 1980 01 01 00 00 00 */
  n_days=(int)(s/86400)+5;

  /* algorithm to get the year (won't work year 2100) */
  /* 0.001 is inserted to get a margin against truncation errors */
  n_days_d=(double)n_days+0.001;
  dat[0]=(int)(n_days_d/365.25)+1980;

  days_in_year=(int)(n_days_d - 365.25*(int)(n_days_d/365.25));

  dat[1]=0;
  for (i=0; i < 12; i++)
    if (dat[0]%4)
      if ((days_in_year - days_before_month_n[i]) >= 0) dat[1]++;
      else ;
    else
      if ((days_in_year - days_before_month_l[i]) >= 0) dat[1]++;
      else ;

  if (dat[0]%4)
    dat[2]=days_in_year - days_before_month_n[dat[1]-1]+1;
  else
    dat[2]=days_in_year - days_before_month_l[dat[1]-1]+1;

}
