#include "decl.h"

long ymdhms2s(int dat[6],int leap_secs)

     // This function converts time and date to
     // the number of GPS seconds
     //
     // Input  dat      : year,months,days,hours,minutes,seconds
     //        leap_sec : number of leap seconds
     //
     // Output ymdhms2s : number of GPS seconds

{

/* Number of seconds since 1980 01 06 00 00 00 UTC. */
/* leap_secs is the number of leap seconds since 1980 01 06. */
/* Assumes dates between 1901 and 2099 in UTC.  */
/* If leap_secs=0, the date represents a 'time in GPS seconds' */

  long s;
  int yr,mn,dy,hr,min,sec,leapdays,new_leapday;
  int days2month[12]={0,31,59,90,120,151,181,212,243,273,304,334};

  yr=dat[0];
  mn=dat[1];
  dy=dat[2];
  hr=dat[3];
  min=dat[4];
  sec=dat[5];

  leapdays=(int)((yr-1976-1)/4);

  if ((yr%4==0)&&(mn>=3))
    new_leapday=1;
  else
    new_leapday=0;


/* first relate to 1980 01 01 00 00 00 then add */
/* the number of leap seconds since 1980 */
/* and finally subtract 5 days to relate to 1980 01 06 00 00 00 */
  s=86400*((yr-1980)*365+leapdays+new_leapday+days2month[mn-1]+dy-1)+
    3600*hr+60*min+sec+leap_secs-5*86400;

  return s;

}

